
                           LookDBF
                           ~~~~~~~
                Смотрелка-редактор DBF-файлов
                ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

[!] Важное замечание     │   Плагин БЕСПЛАТНЫЙ. Для тех же, кто сочтет
[+] Нововведение         │   необходимым вознаградить автора за труд
[-] Исправлена ошибка    │   сообщаю свои реквизиты WebMoney:
[*] Изменения            │   WMID:009807013498, Z804712443609, R420742948431

---------------------------------------------------------------------------
LookDBF 2.04 beta. - 11.12.2005
---------------------------------------------------------------------------
[+] Добавлена поддержка кодовых таблиц FAR. Таблицу можно выбрать Shift+F8
    и в конфигурации плагина. Кодовая таблица так же запоминается и в шаблоне.
    Подробности в разделе подсказки "Кодовые таблицы"
[+] По многочисленным просьбам добавлена операция PACK (Ctrl+F2) - перезапись
    файла с удалением неактуальных записей.
[+] При переходе по номеру записи (Alt+F8) добавлена возможность прыжка на
    заданное число записей от текущей позиции. +N - вниз на N записей.
    -N - вверх на N записей. N - переход к записи номер N (как и было).
[+] Добавлена поддержка полей, не имеющих значения (Null). Смотри раздел
    подсказки _NullFlags. Теперь такие поля отображаются строкой Null. 
[*] Поле _NullFlags теперь отображается в шестнадцатиричном формате.
[+] Добавлена клавиша Ctrl+Del, с помощью которой можно пометить текущее
    поле, как не имеющее значения (установить в Null).
[*] Изменен показ структуры таблицы (F2). Теперь поля, которые могут не
    иметь значения (nullable fields) отмечаются в структуре словом Null.
[+] Добавлена поддержка полей переменной длины V - VarChar и Q - VarBinary,
    введенных в VFP версии 9. Подробности также в разделе подсказки
    _NullFlags.
[-] При экспорте в DBF-файл в заголовках полей не заполнялось смещение поля
    от начала записи и не копировалась служебная информация заголовков полей.
[+] Добавлена поддержка расширенного заголовка DBF-файла, созданного в VFP.
    После заголовка файла и заголовков полей VFP добавляет еще 263 байта,
    где записывает имя файла-контейнера ???.DBC, если таковой имеется.
    При операции PACK (Ctrl+F2) эти байты копируются со старого файла.
    При экспорте в DBF-файл в формате VFP заполняются нулями.
[-] Неверно отображались русские буквы в именах полей при просмотре структуры
    файла (F2).
[+] Добавлен раздел подсказки "Поиск по 3-м и более условиям". Посмотрите.

---------------------------------------------------------------------------
LookDBF 2.03 beta - 25.05.2005
---------------------------------------------------------------------------
[-] Не изменялось пустое символьное поле в режиме редактирования текущего
    поля.
[-] При экспорте в DBF-файл в его заголовок вписывалась нулевая дата
    последнего изменения. Теперь вписывается текущая дата.

---------------------------------------------------------------------------
LookDBF 2.02 beta - 30.04.2005
---------------------------------------------------------------------------
[-] Неверно работал поиск по подстроке в случае, если длина поискового образца
    была больше длины поля.
[-] Неверно работал поиск по условию для символьных полей.

---------------------------------------------------------------------------
LookDBF 2.01 beta - 20.04.2005
---------------------------------------------------------------------------
[-] Не действовал цветовой атрибут s5E - редактируемый текст в помеченной
    записи

---------------------------------------------------------------------------
LookDBF 2.00 beta - 07.04.2005
---------------------------------------------------------------------------
[+] Добавлена конфигурация плагина, которая может быть вызвана как из меню
    Far (Параметры/Параметры внешних модулей/LookDBF), так и непосредственно
    из плагина клавишей (Alt+F1).
    Кроме прочего, конфигурация позволяет задавать формат даты и даты-времени
    (поля D и T) отдельно для показа, отдельно для редактирования/ввода и
    отдельно для экспорта.

[*] Настройка цветов перенесена в конфигурацию.

[+] Введено понятие шаблона. Под шаблоном понимается параметры просмотра файла
    (подробнее см. Help), которые могут сохраняться индивидуально для каждого
    просматриваемого DBF-файла.

[+] Добавлен еще один маскирующий символ (по умолчанию %), который означает
    любое количество любых символов (в том числе и их отсутствие).

[+] Маскирование обоими символами теперь возможно, как при поиске/замене (и в
    поисковой, и в заменяющей строке), так и при поиске по условию равенства
    (=) или неравенства (<>) для символьных полей.

[+] Изменение маскирующих символов теперь возможно как в диалоге "Поиск", так
    и в конфигурации плагина.

[+] В диалоге "Поиск" теперь можно задать инверсию, то есть поиск строк,
    которые НЕ содержат образец.

[+] Для поиска по условию кроме AND и OR добавлены новые операции:
    XOR (исключающее ИЛИ) и NXO (отрицание исключающего ИЛИ). Табличка
    результатов есть в HELP-е. Для поиска по условию добавлен специальный
    раздел HELP-а.

[+] Переработан диалог экспорта, так как "неожиданно" выяснилось, что он не
    влезает в экран в стандартном режиме 80х25. Кроме того, туда добавлена
    возможность задания формата экспорта для даты и времени.

[+] В диалоге экспорта кнопка "Отменить" заменена на кнопку "Сохранить пустую
    базу". Эта кнопка позволяет экспортировать только заголовок. Отменить же
    экспорт можно клавишей Esc или щелчком мышки мимо диалога.

[+] При открытии пустой базы в режиме разрешенного редактирования (опция /e)
    теперь имеется возможность добавить пустую запись в файл.

[+] При замене подстроки в режиме с подтверждением теперь результат будущей
    замены высвечивается в меню подтверждения в нижней строке экрана.

[-] Изменение размеров экрана при выведенном диалоге или хелпе вызывало
    зависание плагина или его выгрузку вместе с падением Far-а.

[-] В некоторых случаях неверно работала опция поиска/замены
    "Только целые слова". Пришлось переписать стандартную функцию IsAlphaNum.

[-] При работе с ФАРом 1.70 альфа 6 пропадала дробная часть числа при суммиро-
    вании и редактировании числовых полей. Эффект был связан с тем, что функция
    FSF.sprintf в этой версии работает иначе, нежели в версии 1.70 бета 5.

[-] Исправлена работа с полями типа B (Double). Ранее при больших значениях
    экспоненты плагин работал неправильно, а то и падал.

---------------------------------------------------------------------------
LookDBF 1.07 beta - 28.06.2004
---------------------------------------------------------------------------
[-] Для некоторых файлов не читался последний мемо-блок. Как показали примеры,
    присланные Русланом Мищенко, Fox обрезает последний мемо-блок, оставляя
    только информативную часть. В результате длина последнего блока оказывается
    меньше, чем длина блока, заявленная в заголовке мемо-файла.

[-] Неверно работала (а то и зацикливалась) замена на пустую строку.

[+] Добавлена возможность задания своего маскирующего символа вместо "?".

[+] Для полей типа D и T теперь запрещена такая замена, при которой длина
    поисковой строки не равна длине заменяющей строки.

[-] Неверно отображались записи при инвертировании пометки (Серая *) в режиме
    "Только помеченные".

[-] Неверно отображались записи при переходе по номеру записи (Alt+F8) в режиме
    "Только помеченные".

[+] Добавлен показ времени, которое занимал экспорт.

[-] Конечные пробелы теперь отбрасываются при редактировании текущего поля
    с типом C (character).

---------------------------------------------------------------------------
LookDBF 1.06 beta - 05.06.2004
---------------------------------------------------------------------------
[-] В процессе замены при некоторых условиях происходило зацикливание. 

[-] В диалоге подтверждения замены "нелегально" использовались цвета для
    редактирования текущей записи.

---------------------------------------------------------------------------
LookDBF 1.05 beta - 27.05.2004
---------------------------------------------------------------------------
[-] Исправлена ошибка при удалении 1-го видимого столбца. 

[+] Добавлена возможность просмотра и редактирования файлов с "мнимыми"
    полями. Пример файла прислал Garry Tomkin. (см.Help. Мнимые поля).

[+] Добавлена возможность задания буфера сортировки (см.Help).

[*] Проведена ревизия исходного текста. Все функции ввода-вывода и работы
    с памятью заменены на стандартные функции Win32 API. LookDBF теперь
    создает свою кучу (heap) памяти, которую удаляет при закрытии.

---------------------------------------------------------------------------
LookDBF 1.04 beta - 20.05.2004
---------------------------------------------------------------------------
[-] Не экспортировались базы, где 1-й байт каждой записи (флаг актуальности) 
    был 0 (вместо пробела).

[+] Добавлена возможность прокрутки колесом мышки. 1 щелчок - 1/4 экрана.

[*] Клавиша F4 теперь открывает диалог редактирования записи, даже если
    редактирование запрещено (параметр /е отсутствует). Однако, в этом случае
    изменения в файле не сохраняются.

[-] Исправлена ошибка редактирования записи. Если в записи присутствовали
    поля I,B,Y они, как правило, обнулялись, даже если не изменялись при
    редактировании.

[+] Добавлена возможность редактирования текущего поля. Клавиша Enter.
    В связи с этим добавилось еще 3 цвета (см.Help). 

[*] Изменен диалог редактирования записи. Теперь все поля даются на
    редактирования в режиме вставки. За исключением типов D и T.

[*] Изменен поиск (Привет Владу Болхову). Поисковая строка теперь ограничена
    255 символами. То же в поиске по условию для символьной строки.

[+] Добавлена возможность задания маски в поисковой строке (см.Help).

[+] Добавлена замена (Клавиша Ctrl+F7). При замене тоже можно маскировать.

[+] Добавлена клавиша для пометки неактуальных записей (Ctrl*).

[+] Добавлена возможность импорта DBF-файла (Клавиша Shift+F9). Подробности
    в Help-е.

[+] При экспорте добавлена сортировка максимум по 3 ключам. Сортировка не
    очень быстрая, поэтому:

[+] При экспорте добавлена индикация процесса в нижней строке экрана и
    возможность прерывания процесса клавишей Esc.

---------------------------------------------------------------------------
LookDBF 1.03 beta - 26.07.2003
---------------------------------------------------------------------------
[*] Переработана строка статуса (см.Help).

[-] Неверно отрабатывали клавиши Ctrl+PgDn и Ctrl+End. (Это называется
    упростил алгоритм... :-)))

[+] Добавлен просмотр Memo-полей формата Visual FoxPro: тип DBF-файла 30,
    расширение мемо-файла FPT.

[+] В командную строку добавлена опция /n - показывать номера записей.
    Оказывается, есть люди, которым это нужно...

[+] Добавлена клавиша Alt+F8 переход по заданному номеру записи.

[+] В строке статуса при просмотре мемо-поля к имеющейся информации добавлен
    номер мемо-блока.

[-] Исправлена ошибка в диалоге поиска строки. В некоторых ситауциях падал
    плагин, иногда вместе с ФАРом.

[-] Исправлена рассогласованость списков полей при поиске по условию. Эта
    рассогласованость проявлялась только при наличии полей типа M,G,0,P.

[+] В командную строку добавлена опция /m - использовать полный экран при
    просмотре мемо-полей

[*] Для просмотра мемо-полей теперь по F3 вызывается вьюер, а по F4 редактор
    FAR. Это позволяет при желании сохранить мемо-поле в виде отдельного файла
    (Shift+F2 из редактора). А с другой стороны, насладится шестнадцатиричным
    режимом просмотра (F4 из вьюера)

[*] Убрана клавиша Ctrl+Shift+E разрешить/запретить редактирование. Так как
    в случае отсутствия разрешения на редактирование в командной строке
    (опция /e) LookDBF теперь открывает файл в режиме "только чтение".

[+] Добавлена клавиша Shift+F2. Редактирование заголовка файла.

---------------------------------------------------------------------------
LookDBF 1.02 beta - 20.07.2003
---------------------------------------------------------------------------
[+] В строку названий полей добавлены индикаторы  и , сигнализирующие
    о наличии невидимых символов за левой или за правой границей столба.

[+] Добавлены клавиши Alt+Home и Alt+End для прокрутки широких столбов
    влево до упора и вправо до упора соответственно.

[-] В широких полях не докручивался последний символ.

[+] Добавлена индикация числа помеченных записей в строке статуса.

[*] Дата теперь показывается полностью ДД/ММ/ГГГГ. Диапазон распознавания
    от 1 года нашей эры до глубокого будущего (9999 года).

[*] Редактирование даты и времени теперь выполняется по маске (разделители
    не изменяемы)

[-] Некорректно размечалась первая видимая строка в режиме "Только помеченные".

[+] Добавлен просмотр Memo-полей формата FoxPro: тип DBF-файла F5, расширение
    мемо-файла FPT. (Огромное спасибо Сергею Ковалеву за исчерпывающую информа-
    цию, примеры и исходники по работе с мемо-файлами).

[*] В просмотре мемо-поля вместо имени временного файла показывается имя
    мемо-поля и номер записи DBF-файла.

[-] Исправлены ошибки при навигации мышкой.

[-] Исправлены ошибки при навигации в режиме "Только помеченные".

[*] Изменен диалог поиска подстроки. Убраны лишние кнопки. Радио-кнопки
    заменены на обычные.

[*] Изменен диалог экспорта. Вид его теперь динамически изменяется в зави-
    симости от выбранного формата.

[+] Добавлен поиск по условию. Клавиша Alt+F7.

---------------------------------------------------------------------------
LookDBF 1.01 beta - 07.07.2003
---------------------------------------------------------------------------
[!] По умолчанию редактирование теперь запрещено.

[+] В командную строку добавлена опция /e - разрешение редактирования.

[+] Добавлена клавиша Ctrl+Shift+E разрешить/запретить редактирование.

[+] В строке статуса добавлен признак запрета редактирования "#".

[+] Добавлена возможность просмотра файлов защищенных от записи. При
    просмотре таких файлов редактирование запрещено и изменение этого
    режима Ctrl+Shift+E заблокировано.

[*] Переписан разбор командной строки. Стал более логичным (см. Help).

[*] Копирование в карман и по Ctrl+C, оконечные пробелы отбрасываются.

[*] Переписаны Help-файлы. Надеюсь, стало понятнее.

[+] Добавлена настройка цветов.

[*] История строки для поиска совмещена с общей FAR-овской "SearchText".

[+] Добавлен просмотр Memo-полей. Пока только 2-х форматов: dBaseIII+
    (тип DBF-файла 83) и dBaseIV (тип DBF-файла 8b). К сожалению, по
    другим типам Memo-полей не имею информации о структуре Memo-файлов.
    Если кто-нибудь располагает, не сочтите за труд прислать либо саму
    информацию, либо ссылку в Интернет.

[*] Изменен показ Memo-поля в основном окне. Теперь слово Memo появляется
    только в тех записях, где есть ссылка на Memo-блок. В противном случае
    показываются пробелы.

[-] Неверно отрабатывало определение кодировки при экспорте.

[*] При экспорте в текстовый файл в кодировке Win разделитель "│" (код B3)
    перекодируется в код A6 - символ │ в кодировке Win.

[*] Широкие поля, не влезающие в экран, при открытии файла ужимаются до
    размеров экрана.

[+] Добавлены клавиши Alt─ и Alt─ для прокрутки широких полей.

[*] Теперь цветовое выделение активной ячейки не превышает визуализируемую
    ширину поля DBF (Визуализируемая ширина совпадает с физической шириной
    для символьных полей C,N,L,...И превышает физическую длину для бинарных
    полей. Скажем, для типа I физическая ширина 4, визуализируемая 11)

[+] Нажатие ENTER в списке полей базы (F2) переводит курсор в этот столбец.
    Если столбец спрятан, он вставляется перед текущей позицией.

[+] Вставленный (Shift+Ins) столбец становится текущим, даже если вставка
    делается перед первым видимым столбцом.

[-] Исправлены некорректности при редактировании полей.

---------------------------------------------------------------------------
LookDBF 1.00 beta - 20.06.2003   Первый релиз
---------------------------------------------------------------------------
